<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'CreateFileMailing' => '\\StructType\\CreateFileMailing',
            'CreateFileMailingResponse' => '\\StructType\\CreateFileMailingResponse',
            'CreateMailing' => '\\StructType\\CreateMailing',
            'CreateMailingResponse' => '\\StructType\\CreateMailingResponse',
            'AddMailingFilter' => '\\StructType\\AddMailingFilter',
            'AddMailingFilterResponse' => '\\StructType\\AddMailingFilterResponse',
            'AddDeliveryAddress' => '\\StructType\\AddDeliveryAddress',
            'AddDeliveryAddressResponse' => '\\StructType\\AddDeliveryAddressResponse',
            'UpdateMailingOptions' => '\\StructType\\UpdateMailingOptions',
            'UpdateMailingOptionsResponse' => '\\StructType\\UpdateMailingOptionsResponse',
            'AddTemplateFile' => '\\StructType\\AddTemplateFile',
            'AddTemplateFileResponse' => '\\StructType\\AddTemplateFileResponse',
            'AddTemplateBackgroundFile' => '\\StructType\\AddTemplateBackgroundFile',
            'AddTemplateBackgroundFileResponse' => '\\StructType\\AddTemplateBackgroundFileResponse',
            'AddTemplateFromLibrary' => '\\StructType\\AddTemplateFromLibrary',
            'AddTemplateFromLibraryResponse' => '\\StructType\\AddTemplateFromLibraryResponse',
            'AddTemplateFromOrder' => '\\StructType\\AddTemplateFromOrder',
            'AddTemplateFromOrderResponse' => '\\StructType\\AddTemplateFromOrderResponse',
            'AddMailPackFromLibrary' => '\\StructType\\AddMailPackFromLibrary',
            'AddMailPackFromLibraryResponse' => '\\StructType\\AddMailPackFromLibraryResponse',
            'AddMailPackFromOrder' => '\\StructType\\AddMailPackFromOrder',
            'AddMailPackFromOrderResponse' => '\\StructType\\AddMailPackFromOrderResponse',
            'AddDesignerTemplate' => '\\StructType\\AddDesignerTemplate',
            'AddDesignerTemplateResponse' => '\\StructType\\AddDesignerTemplateResponse',
            'AddDesignerImage' => '\\StructType\\AddDesignerImage',
            'AddDesignerImageResponse' => '\\StructType\\AddDesignerImageResponse',
            'AddDesignerStoredImage' => '\\StructType\\AddDesignerStoredImage',
            'AddDesignerStoredImageResponse' => '\\StructType\\AddDesignerStoredImageResponse',
            'AddDesignerText' => '\\StructType\\AddDesignerText',
            'AddDesignerTextResponse' => '\\StructType\\AddDesignerTextResponse',
            'SetMailPackVariableValue' => '\\StructType\\SetMailPackVariableValue',
            'SetMailPackVariableValueResponse' => '\\StructType\\SetMailPackVariableValueResponse',
            'SetTemplateVariableValue' => '\\StructType\\SetTemplateVariableValue',
            'SetTemplateVariableValueResponse' => '\\StructType\\SetTemplateVariableValueResponse',
            'AddTemplateUseRule' => '\\StructType\\AddTemplateUseRule',
            'AddTemplateUseRuleResponse' => '\\StructType\\AddTemplateUseRuleResponse',
            'AddTemplateBackgroundRule' => '\\StructType\\AddTemplateBackgroundRule',
            'AddTemplateBackgroundRuleResponse' => '\\StructType\\AddTemplateBackgroundRuleResponse',
            'AddMailingListFile' => '\\StructType\\AddMailingListFile',
            'AddMailingListFileResponse' => '\\StructType\\AddMailingListFileResponse',
            'AddMailingListString' => '\\StructType\\AddMailingListString',
            'AddMailingListStringResponse' => '\\StructType\\AddMailingListStringResponse',
            'AddMailingListFromLibrary' => '\\StructType\\AddMailingListFromLibrary',
            'AddMailingListFromLibraryResponse' => '\\StructType\\AddMailingListFromLibraryResponse',
            'AddMailingListFromOrder' => '\\StructType\\AddMailingListFromOrder',
            'AddMailingListFromOrderResponse' => '\\StructType\\AddMailingListFromOrderResponse',
            'AddAddress' => '\\StructType\\AddAddress',
            'AddAddressResponse' => '\\StructType\\AddAddressResponse',
            'AddSelf' => '\\StructType\\AddSelf',
            'AddSelfResponse' => '\\StructType\\AddSelfResponse',
            'AutoCorrectAddresses' => '\\StructType\\AutoCorrectAddresses',
            'AutoCorrectAddressesResponse' => '\\StructType\\AutoCorrectAddressesResponse',
            'SetMailingListProofOption' => '\\StructType\\SetMailingListProofOption',
            'SetMailingListProofOptionResponse' => '\\StructType\\SetMailingListProofOptionResponse',
            'CancelMailing' => '\\StructType\\CancelMailing',
            'CancelMailingResponse' => '\\StructType\\CancelMailingResponse',
            'DeleteMailing' => '\\StructType\\DeleteMailing',
            'DeleteMailingResponse' => '\\StructType\\DeleteMailingResponse',
            'DeleteTemplate' => '\\StructType\\DeleteTemplate',
            'DeleteTemplateResponse' => '\\StructType\\DeleteTemplateResponse',
            'DeleteMailPack' => '\\StructType\\DeleteMailPack',
            'DeleteMailPackResponse' => '\\StructType\\DeleteMailPackResponse',
            'DeleteMailingList' => '\\StructType\\DeleteMailingList',
            'DeleteMailingListResponse' => '\\StructType\\DeleteMailingListResponse',
            'GetTemplateImage' => '\\StructType\\GetTemplateImage',
            'GetTemplateImageResponse' => '\\StructType\\GetTemplateImageResponse',
            'ProcessMailing' => '\\StructType\\ProcessMailing',
            'ProcessMailingResponse' => '\\StructType\\ProcessMailingResponse',
            'GetMailingDetails' => '\\StructType\\GetMailingDetails',
            'GetMailingDetailsResponse' => '\\StructType\\GetMailingDetailsResponse',
            'GetStatus' => '\\StructType\\GetStatus',
            'GetStatusResponse' => '\\StructType\\GetStatusResponse',
            'GetProofFile' => '\\StructType\\GetProofFile',
            'GetProofFileResponse' => '\\StructType\\GetProofFileResponse',
            'GetProofImage' => '\\StructType\\GetProofImage',
            'GetProofImageResponse' => '\\StructType\\GetProofImageResponse',
            'GetBalance' => '\\StructType\\GetBalance',
            'GetBalanceResponse' => '\\StructType\\GetBalanceResponse',
            'GetMailingGUIDFromOrderRef' => '\\StructType\\GetMailingGUIDFromOrderRef',
            'GetMailingGUIDFromOrderRefResponse' => '\\StructType\\GetMailingGUIDFromOrderRefResponse',
            'UserApproveMailing' => '\\StructType\\UserApproveMailing',
            'UserApproveMailingResponse' => '\\StructType\\UserApproveMailingResponse',
            'CancelMailingApproval' => '\\StructType\\CancelMailingApproval',
            'CancelMailingApprovalResponse' => '\\StructType\\CancelMailingApprovalResponse',
            'ListMailings' => '\\StructType\\ListMailings',
            'ListMailingsResponse' => '\\StructType\\ListMailingsResponse',
            'ListMailingsPageCount' => '\\StructType\\ListMailingsPageCount',
            'ListMailingsPageCountResponse' => '\\StructType\\ListMailingsPageCountResponse',
            'ListLibraryTemplates' => '\\StructType\\ListLibraryTemplates',
            'ListLibraryTemplatesResponse' => '\\StructType\\ListLibraryTemplatesResponse',
            'ListLibraryTemplatesPageCount' => '\\StructType\\ListLibraryTemplatesPageCount',
            'ListLibraryTemplatesPageCountResponse' => '\\StructType\\ListLibraryTemplatesPageCountResponse',
            'ListLibraryBackgrounds' => '\\StructType\\ListLibraryBackgrounds',
            'ListLibraryBackgroundsResponse' => '\\StructType\\ListLibraryBackgroundsResponse',
            'ListLibraryBackgroundsPageCount' => '\\StructType\\ListLibraryBackgroundsPageCount',
            'ListLibraryBackgroundsPageCountResponse' => '\\StructType\\ListLibraryBackgroundsPageCountResponse',
            'ListLibraryMailPacks' => '\\StructType\\ListLibraryMailPacks',
            'ListLibraryMailPacksResponse' => '\\StructType\\ListLibraryMailPacksResponse',
            'ListLibraryMailPacksPageCount' => '\\StructType\\ListLibraryMailPacksPageCount',
            'ListLibraryMailPacksPageCountResponse' => '\\StructType\\ListLibraryMailPacksPageCountResponse',
            'ListLibraryMailingLists' => '\\StructType\\ListLibraryMailingLists',
            'ListLibraryMailingListsResponse' => '\\StructType\\ListLibraryMailingListsResponse',
            'ListLibraryMailingListsPageCount' => '\\StructType\\ListLibraryMailingListsPageCount',
            'ListLibraryMailingListsPageCountResponse' => '\\StructType\\ListLibraryMailingListsPageCountResponse',
            'ListMailingFilterCategories' => '\\StructType\\ListMailingFilterCategories',
            'ListMailingFilterCategoriesResponse' => '\\StructType\\ListMailingFilterCategoriesResponse',
            'ListMailingFiltersForCategory' => '\\StructType\\ListMailingFiltersForCategory',
            'ListMailingFiltersForCategoryResponse' => '\\StructType\\ListMailingFiltersForCategoryResponse',
            'ListTemplateVariables' => '\\StructType\\ListTemplateVariables',
            'ListTemplateVariablesResponse' => '\\StructType\\ListTemplateVariablesResponse',
            'ListMailingVariableValues' => '\\StructType\\ListMailingVariableValues',
            'ListMailingVariableValuesResponse' => '\\StructType\\ListMailingVariableValuesResponse',
            'ListProductTypes' => '\\StructType\\ListProductTypes',
            'ListProductTypesResponse' => '\\StructType\\ListProductTypesResponse',
            'ListDocumentTypes' => '\\StructType\\ListDocumentTypes',
            'ListDocumentTypesResponse' => '\\StructType\\ListDocumentTypesResponse',
            'CreateAccount' => '\\StructType\\CreateAccount',
            'CreateAccountResponse' => '\\StructType\\CreateAccountResponse',
            'AddUser' => '\\StructType\\AddUser',
            'AddUserResponse' => '\\StructType\\AddUserResponse',
            'AddUserOrganisationStructureLink' => '\\StructType\\AddUserOrganisationStructureLink',
            'AddUserOrganisationStructureLinkResponse' => '\\StructType\\AddUserOrganisationStructureLinkResponse',
            'AddUserSignupData' => '\\StructType\\AddUserSignupData',
            'AddUserSignupDataResponse' => '\\StructType\\AddUserSignupDataResponse',
            'AddMailingListFileToLibrary' => '\\StructType\\AddMailingListFileToLibrary',
            'AddMailingListFileToLibraryResponse' => '\\StructType\\AddMailingListFileToLibraryResponse',
            'AddMailingListStringToLibrary' => '\\StructType\\AddMailingListStringToLibrary',
            'AddMailingListStringToLibraryResponse' => '\\StructType\\AddMailingListStringToLibraryResponse',
            'AddTemplateFileToLibrary' => '\\StructType\\AddTemplateFileToLibrary',
            'AddTemplateFileToLibraryResponse' => '\\StructType\\AddTemplateFileToLibraryResponse',
            'AddBackgroundFileToLibrary' => '\\StructType\\AddBackgroundFileToLibrary',
            'AddBackgroundFileToLibraryResponse' => '\\StructType\\AddBackgroundFileToLibraryResponse',
            'AddMailPackToLibrary' => '\\StructType\\AddMailPackToLibrary',
            'AddMailPackToLibraryResponse' => '\\StructType\\AddMailPackToLibraryResponse',
            'AddTemplateToLibraryMailPack' => '\\StructType\\AddTemplateToLibraryMailPack',
            'AddTemplateToLibraryMailPackResponse' => '\\StructType\\AddTemplateToLibraryMailPackResponse',
            'AddMailingListStringForAddressCount' => '\\StructType\\AddMailingListStringForAddressCount',
            'AddMailingListStringForAddressCountResponse' => '\\StructType\\AddMailingListStringForAddressCountResponse',
            'AddMailingListFileForAddressCount' => '\\StructType\\AddMailingListFileForAddressCount',
            'AddMailingListFileForAddressCountResponse' => '\\StructType\\AddMailingListFileForAddressCountResponse',
            'PollMailingListAddressCounts' => '\\StructType\\PollMailingListAddressCounts',
            'PollMailingListAddressCountsResponse' => '\\StructType\\PollMailingListAddressCountsResponse',
            'GetMailingPriceEstimate' => '\\StructType\\GetMailingPriceEstimate',
            'GetMailingPriceEstimateResponse' => '\\StructType\\GetMailingPriceEstimateResponse',
            'GetPriceEstimate' => '\\StructType\\GetPriceEstimate',
            'GetPriceEstimateResponse' => '\\StructType\\GetPriceEstimateResponse',
            'GetMailPackZip' => '\\StructType\\GetMailPackZip',
            'GetMailPackZipResponse' => '\\StructType\\GetMailPackZipResponse',
            'GetMailingListZip' => '\\StructType\\GetMailingListZip',
            'GetMailingListZipResponse' => '\\StructType\\GetMailingListZipResponse',
            'ExtendedCall' => '\\StructType\\ExtendedCall',
            'ArrayOfExtendedProperty' => '\\ArrayType\\ArrayOfExtendedProperty',
            'ExtendedProperty' => '\\StructType\\ExtendedProperty',
            'ExtendedCallResponse' => '\\StructType\\ExtendedCallResponse',
            'ExtendedCallDefinition' => '\\StructType\\ExtendedCallDefinition',
            'ExtendedCallDefinitionResponse' => '\\StructType\\ExtendedCallDefinitionResponse',
        );
    }
}
