<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddMailingListFileToLibrary StructType
 * @subpackage Structs
 */
class AddMailingListFileToLibrary extends AbstractStructBase
{
    /**
     * The HasHeaders
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $HasHeaders;
    /**
     * The Username
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Username;
    /**
     * The Password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The MailingListName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MailingListName;
    /**
     * The FileName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FileName;
    /**
     * The MailingListData
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MailingListData;
    /**
     * The FileType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FileType;
    /**
     * The SheetName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SheetName;
    /**
     * The MappingDelimiter
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MappingDelimiter;
    /**
     * The MappingFixedWidthChars
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MappingFixedWidthChars;
    /**
     * The MappingName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MappingName;
    /**
     * The ReturnFormat
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReturnFormat;
    /**
     * Constructor method for AddMailingListFileToLibrary
     * @uses AddMailingListFileToLibrary::setHasHeaders()
     * @uses AddMailingListFileToLibrary::setUsername()
     * @uses AddMailingListFileToLibrary::setPassword()
     * @uses AddMailingListFileToLibrary::setMailingListName()
     * @uses AddMailingListFileToLibrary::setFileName()
     * @uses AddMailingListFileToLibrary::setMailingListData()
     * @uses AddMailingListFileToLibrary::setFileType()
     * @uses AddMailingListFileToLibrary::setSheetName()
     * @uses AddMailingListFileToLibrary::setMappingDelimiter()
     * @uses AddMailingListFileToLibrary::setMappingFixedWidthChars()
     * @uses AddMailingListFileToLibrary::setMappingName()
     * @uses AddMailingListFileToLibrary::setReturnFormat()
     * @param bool $hasHeaders
     * @param string $username
     * @param string $password
     * @param string $mailingListName
     * @param string $fileName
     * @param string $mailingListData
     * @param string $fileType
     * @param string $sheetName
     * @param string $mappingDelimiter
     * @param string $mappingFixedWidthChars
     * @param string $mappingName
     * @param string $returnFormat
     */
    public function __construct($hasHeaders = null, $username = null, $password = null, $mailingListName = null, $fileName = null, $mailingListData = null, $fileType = null, $sheetName = null, $mappingDelimiter = null, $mappingFixedWidthChars = null, $mappingName = null, $returnFormat = null)
    {
        $this
            ->setHasHeaders($hasHeaders)
            ->setUsername($username)
            ->setPassword($password)
            ->setMailingListName($mailingListName)
            ->setFileName($fileName)
            ->setMailingListData($mailingListData)
            ->setFileType($fileType)
            ->setSheetName($sheetName)
            ->setMappingDelimiter($mappingDelimiter)
            ->setMappingFixedWidthChars($mappingFixedWidthChars)
            ->setMappingName($mappingName)
            ->setReturnFormat($returnFormat);
    }
    /**
     * Get HasHeaders value
     * @return bool
     */
    public function getHasHeaders()
    {
        return $this->HasHeaders;
    }
    /**
     * Set HasHeaders value
     * @param bool $hasHeaders
     * @return \StructType\AddMailingListFileToLibrary
     */
    public function setHasHeaders($hasHeaders = null)
    {
        // validation for constraint: boolean
        if (!is_null($hasHeaders) && !is_bool($hasHeaders)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($hasHeaders)), __LINE__);
        }
        $this->HasHeaders = $hasHeaders;
        return $this;
    }
    /**
     * Get Username value
     * @return string|null
     */
    public function getUsername()
    {
        return $this->Username;
    }
    /**
     * Set Username value
     * @param string $username
     * @return \StructType\AddMailingListFileToLibrary
     */
    public function setUsername($username = null)
    {
        // validation for constraint: string
        if (!is_null($username) && !is_string($username)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($username)), __LINE__);
        }
        $this->Username = $username;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\AddMailingListFileToLibrary
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get MailingListName value
     * @return string|null
     */
    public function getMailingListName()
    {
        return $this->MailingListName;
    }
    /**
     * Set MailingListName value
     * @param string $mailingListName
     * @return \StructType\AddMailingListFileToLibrary
     */
    public function setMailingListName($mailingListName = null)
    {
        // validation for constraint: string
        if (!is_null($mailingListName) && !is_string($mailingListName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mailingListName)), __LINE__);
        }
        $this->MailingListName = $mailingListName;
        return $this;
    }
    /**
     * Get FileName value
     * @return string|null
     */
    public function getFileName()
    {
        return $this->FileName;
    }
    /**
     * Set FileName value
     * @param string $fileName
     * @return \StructType\AddMailingListFileToLibrary
     */
    public function setFileName($fileName = null)
    {
        // validation for constraint: string
        if (!is_null($fileName) && !is_string($fileName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fileName)), __LINE__);
        }
        $this->FileName = $fileName;
        return $this;
    }
    /**
     * Get MailingListData value
     * @return string|null
     */
    public function getMailingListData()
    {
        return $this->MailingListData;
    }
    /**
     * Set MailingListData value
     * @param string $mailingListData
     * @return \StructType\AddMailingListFileToLibrary
     */
    public function setMailingListData($mailingListData = null)
    {
        // validation for constraint: string
        if (!is_null($mailingListData) && !is_string($mailingListData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mailingListData)), __LINE__);
        }
        $this->MailingListData = $mailingListData;
        return $this;
    }
    /**
     * Get FileType value
     * @return string|null
     */
    public function getFileType()
    {
        return $this->FileType;
    }
    /**
     * Set FileType value
     * @param string $fileType
     * @return \StructType\AddMailingListFileToLibrary
     */
    public function setFileType($fileType = null)
    {
        // validation for constraint: string
        if (!is_null($fileType) && !is_string($fileType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fileType)), __LINE__);
        }
        $this->FileType = $fileType;
        return $this;
    }
    /**
     * Get SheetName value
     * @return string|null
     */
    public function getSheetName()
    {
        return $this->SheetName;
    }
    /**
     * Set SheetName value
     * @param string $sheetName
     * @return \StructType\AddMailingListFileToLibrary
     */
    public function setSheetName($sheetName = null)
    {
        // validation for constraint: string
        if (!is_null($sheetName) && !is_string($sheetName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sheetName)), __LINE__);
        }
        $this->SheetName = $sheetName;
        return $this;
    }
    /**
     * Get MappingDelimiter value
     * @return string|null
     */
    public function getMappingDelimiter()
    {
        return $this->MappingDelimiter;
    }
    /**
     * Set MappingDelimiter value
     * @param string $mappingDelimiter
     * @return \StructType\AddMailingListFileToLibrary
     */
    public function setMappingDelimiter($mappingDelimiter = null)
    {
        // validation for constraint: string
        if (!is_null($mappingDelimiter) && !is_string($mappingDelimiter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mappingDelimiter)), __LINE__);
        }
        $this->MappingDelimiter = $mappingDelimiter;
        return $this;
    }
    /**
     * Get MappingFixedWidthChars value
     * @return string|null
     */
    public function getMappingFixedWidthChars()
    {
        return $this->MappingFixedWidthChars;
    }
    /**
     * Set MappingFixedWidthChars value
     * @param string $mappingFixedWidthChars
     * @return \StructType\AddMailingListFileToLibrary
     */
    public function setMappingFixedWidthChars($mappingFixedWidthChars = null)
    {
        // validation for constraint: string
        if (!is_null($mappingFixedWidthChars) && !is_string($mappingFixedWidthChars)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mappingFixedWidthChars)), __LINE__);
        }
        $this->MappingFixedWidthChars = $mappingFixedWidthChars;
        return $this;
    }
    /**
     * Get MappingName value
     * @return string|null
     */
    public function getMappingName()
    {
        return $this->MappingName;
    }
    /**
     * Set MappingName value
     * @param string $mappingName
     * @return \StructType\AddMailingListFileToLibrary
     */
    public function setMappingName($mappingName = null)
    {
        // validation for constraint: string
        if (!is_null($mappingName) && !is_string($mappingName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mappingName)), __LINE__);
        }
        $this->MappingName = $mappingName;
        return $this;
    }
    /**
     * Get ReturnFormat value
     * @return string|null
     */
    public function getReturnFormat()
    {
        return $this->ReturnFormat;
    }
    /**
     * Set ReturnFormat value
     * @param string $returnFormat
     * @return \StructType\AddMailingListFileToLibrary
     */
    public function setReturnFormat($returnFormat = null)
    {
        // validation for constraint: string
        if (!is_null($returnFormat) && !is_string($returnFormat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($returnFormat)), __LINE__);
        }
        $this->ReturnFormat = $returnFormat;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddMailingListFileToLibrary
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
