<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddTemplateFile StructType
 * @subpackage Structs
 */
class AddTemplateFile extends AbstractStructBase
{
    /**
     * The MailingGUID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - pattern: [0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}
     * @var string
     */
    public $MailingGUID;
    /**
     * The AddressedDocument
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $AddressedDocument;
    /**
     * The CanBeginOnBack
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $CanBeginOnBack;
    /**
     * The NextTemplateCanBeginOnBack
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $NextTemplateCanBeginOnBack;
    /**
     * The BleedSupplied
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $BleedSupplied;
    /**
     * The Copies
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Copies;
    /**
     * The Instances
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Instances;
    /**
     * The CycleInstancesOnCopies
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $CycleInstancesOnCopies;
    /**
     * The Username
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Username;
    /**
     * The Password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The TemplateName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemplateName;
    /**
     * The FileName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FileName;
    /**
     * The FileData
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FileData;
    /**
     * The DocumentType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DocumentType;
    /**
     * The AddressFontCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $AddressFontCode;
    /**
     * The TemplateType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemplateType;
    /**
     * The BackgroundName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $BackgroundName;
    /**
     * The ProtectedAreaPassword
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ProtectedAreaPassword;
    /**
     * The EncryptionPassword
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $EncryptionPassword;
    /**
     * The InstancePageNumbers
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InstancePageNumbers;
    /**
     * The ReturnFormat
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReturnFormat;
    /**
     * Constructor method for AddTemplateFile
     * @uses AddTemplateFile::setMailingGUID()
     * @uses AddTemplateFile::setAddressedDocument()
     * @uses AddTemplateFile::setCanBeginOnBack()
     * @uses AddTemplateFile::setNextTemplateCanBeginOnBack()
     * @uses AddTemplateFile::setBleedSupplied()
     * @uses AddTemplateFile::setCopies()
     * @uses AddTemplateFile::setInstances()
     * @uses AddTemplateFile::setCycleInstancesOnCopies()
     * @uses AddTemplateFile::setUsername()
     * @uses AddTemplateFile::setPassword()
     * @uses AddTemplateFile::setTemplateName()
     * @uses AddTemplateFile::setFileName()
     * @uses AddTemplateFile::setFileData()
     * @uses AddTemplateFile::setDocumentType()
     * @uses AddTemplateFile::setAddressFontCode()
     * @uses AddTemplateFile::setTemplateType()
     * @uses AddTemplateFile::setBackgroundName()
     * @uses AddTemplateFile::setProtectedAreaPassword()
     * @uses AddTemplateFile::setEncryptionPassword()
     * @uses AddTemplateFile::setInstancePageNumbers()
     * @uses AddTemplateFile::setReturnFormat()
     * @param string $mailingGUID
     * @param bool $addressedDocument
     * @param bool $canBeginOnBack
     * @param bool $nextTemplateCanBeginOnBack
     * @param bool $bleedSupplied
     * @param int $copies
     * @param int $instances
     * @param bool $cycleInstancesOnCopies
     * @param string $username
     * @param string $password
     * @param string $templateName
     * @param string $fileName
     * @param string $fileData
     * @param string $documentType
     * @param string $addressFontCode
     * @param string $templateType
     * @param string $backgroundName
     * @param string $protectedAreaPassword
     * @param string $encryptionPassword
     * @param string $instancePageNumbers
     * @param string $returnFormat
     */
    public function __construct($mailingGUID = null, $addressedDocument = null, $canBeginOnBack = null, $nextTemplateCanBeginOnBack = null, $bleedSupplied = null, $copies = null, $instances = null, $cycleInstancesOnCopies = null, $username = null, $password = null, $templateName = null, $fileName = null, $fileData = null, $documentType = null, $addressFontCode = null, $templateType = null, $backgroundName = null, $protectedAreaPassword = null, $encryptionPassword = null, $instancePageNumbers = null, $returnFormat = null)
    {
        $this
            ->setMailingGUID($mailingGUID)
            ->setAddressedDocument($addressedDocument)
            ->setCanBeginOnBack($canBeginOnBack)
            ->setNextTemplateCanBeginOnBack($nextTemplateCanBeginOnBack)
            ->setBleedSupplied($bleedSupplied)
            ->setCopies($copies)
            ->setInstances($instances)
            ->setCycleInstancesOnCopies($cycleInstancesOnCopies)
            ->setUsername($username)
            ->setPassword($password)
            ->setTemplateName($templateName)
            ->setFileName($fileName)
            ->setFileData($fileData)
            ->setDocumentType($documentType)
            ->setAddressFontCode($addressFontCode)
            ->setTemplateType($templateType)
            ->setBackgroundName($backgroundName)
            ->setProtectedAreaPassword($protectedAreaPassword)
            ->setEncryptionPassword($encryptionPassword)
            ->setInstancePageNumbers($instancePageNumbers)
            ->setReturnFormat($returnFormat);
    }
    /**
     * Get MailingGUID value
     * @return string
     */
    public function getMailingGUID()
    {
        return $this->MailingGUID;
    }
    /**
     * Set MailingGUID value
     * @param string $mailingGUID
     * @return \StructType\AddTemplateFile
     */
    public function setMailingGUID($mailingGUID = null)
    {
        // validation for constraint: pattern
        if (is_scalar($mailingGUID) && !preg_match('/[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}/', $mailingGUID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}", "%s" given', var_export($mailingGUID, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($mailingGUID) && !is_string($mailingGUID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mailingGUID)), __LINE__);
        }
        $this->MailingGUID = $mailingGUID;
        return $this;
    }
    /**
     * Get AddressedDocument value
     * @return bool
     */
    public function getAddressedDocument()
    {
        return $this->AddressedDocument;
    }
    /**
     * Set AddressedDocument value
     * @param bool $addressedDocument
     * @return \StructType\AddTemplateFile
     */
    public function setAddressedDocument($addressedDocument = null)
    {
        // validation for constraint: boolean
        if (!is_null($addressedDocument) && !is_bool($addressedDocument)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($addressedDocument)), __LINE__);
        }
        $this->AddressedDocument = $addressedDocument;
        return $this;
    }
    /**
     * Get CanBeginOnBack value
     * @return bool
     */
    public function getCanBeginOnBack()
    {
        return $this->CanBeginOnBack;
    }
    /**
     * Set CanBeginOnBack value
     * @param bool $canBeginOnBack
     * @return \StructType\AddTemplateFile
     */
    public function setCanBeginOnBack($canBeginOnBack = null)
    {
        // validation for constraint: boolean
        if (!is_null($canBeginOnBack) && !is_bool($canBeginOnBack)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($canBeginOnBack)), __LINE__);
        }
        $this->CanBeginOnBack = $canBeginOnBack;
        return $this;
    }
    /**
     * Get NextTemplateCanBeginOnBack value
     * @return bool
     */
    public function getNextTemplateCanBeginOnBack()
    {
        return $this->NextTemplateCanBeginOnBack;
    }
    /**
     * Set NextTemplateCanBeginOnBack value
     * @param bool $nextTemplateCanBeginOnBack
     * @return \StructType\AddTemplateFile
     */
    public function setNextTemplateCanBeginOnBack($nextTemplateCanBeginOnBack = null)
    {
        // validation for constraint: boolean
        if (!is_null($nextTemplateCanBeginOnBack) && !is_bool($nextTemplateCanBeginOnBack)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($nextTemplateCanBeginOnBack)), __LINE__);
        }
        $this->NextTemplateCanBeginOnBack = $nextTemplateCanBeginOnBack;
        return $this;
    }
    /**
     * Get BleedSupplied value
     * @return bool
     */
    public function getBleedSupplied()
    {
        return $this->BleedSupplied;
    }
    /**
     * Set BleedSupplied value
     * @param bool $bleedSupplied
     * @return \StructType\AddTemplateFile
     */
    public function setBleedSupplied($bleedSupplied = null)
    {
        // validation for constraint: boolean
        if (!is_null($bleedSupplied) && !is_bool($bleedSupplied)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($bleedSupplied)), __LINE__);
        }
        $this->BleedSupplied = $bleedSupplied;
        return $this;
    }
    /**
     * Get Copies value
     * @return int
     */
    public function getCopies()
    {
        return $this->Copies;
    }
    /**
     * Set Copies value
     * @param int $copies
     * @return \StructType\AddTemplateFile
     */
    public function setCopies($copies = null)
    {
        // validation for constraint: int
        if (!is_null($copies) && !is_numeric($copies)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($copies)), __LINE__);
        }
        $this->Copies = $copies;
        return $this;
    }
    /**
     * Get Instances value
     * @return int
     */
    public function getInstances()
    {
        return $this->Instances;
    }
    /**
     * Set Instances value
     * @param int $instances
     * @return \StructType\AddTemplateFile
     */
    public function setInstances($instances = null)
    {
        // validation for constraint: int
        if (!is_null($instances) && !is_numeric($instances)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($instances)), __LINE__);
        }
        $this->Instances = $instances;
        return $this;
    }
    /**
     * Get CycleInstancesOnCopies value
     * @return bool
     */
    public function getCycleInstancesOnCopies()
    {
        return $this->CycleInstancesOnCopies;
    }
    /**
     * Set CycleInstancesOnCopies value
     * @param bool $cycleInstancesOnCopies
     * @return \StructType\AddTemplateFile
     */
    public function setCycleInstancesOnCopies($cycleInstancesOnCopies = null)
    {
        // validation for constraint: boolean
        if (!is_null($cycleInstancesOnCopies) && !is_bool($cycleInstancesOnCopies)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($cycleInstancesOnCopies)), __LINE__);
        }
        $this->CycleInstancesOnCopies = $cycleInstancesOnCopies;
        return $this;
    }
    /**
     * Get Username value
     * @return string|null
     */
    public function getUsername()
    {
        return $this->Username;
    }
    /**
     * Set Username value
     * @param string $username
     * @return \StructType\AddTemplateFile
     */
    public function setUsername($username = null)
    {
        // validation for constraint: string
        if (!is_null($username) && !is_string($username)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($username)), __LINE__);
        }
        $this->Username = $username;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\AddTemplateFile
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get TemplateName value
     * @return string|null
     */
    public function getTemplateName()
    {
        return $this->TemplateName;
    }
    /**
     * Set TemplateName value
     * @param string $templateName
     * @return \StructType\AddTemplateFile
     */
    public function setTemplateName($templateName = null)
    {
        // validation for constraint: string
        if (!is_null($templateName) && !is_string($templateName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($templateName)), __LINE__);
        }
        $this->TemplateName = $templateName;
        return $this;
    }
    /**
     * Get FileName value
     * @return string|null
     */
    public function getFileName()
    {
        return $this->FileName;
    }
    /**
     * Set FileName value
     * @param string $fileName
     * @return \StructType\AddTemplateFile
     */
    public function setFileName($fileName = null)
    {
        // validation for constraint: string
        if (!is_null($fileName) && !is_string($fileName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fileName)), __LINE__);
        }
        $this->FileName = $fileName;
        return $this;
    }
    /**
     * Get FileData value
     * @return string|null
     */
    public function getFileData()
    {
        return $this->FileData;
    }
    /**
     * Set FileData value
     * @param string $fileData
     * @return \StructType\AddTemplateFile
     */
    public function setFileData($fileData = null)
    {
        // validation for constraint: string
        if (!is_null($fileData) && !is_string($fileData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fileData)), __LINE__);
        }
        $this->FileData = $fileData;
        return $this;
    }
    /**
     * Get DocumentType value
     * @return string|null
     */
    public function getDocumentType()
    {
        return $this->DocumentType;
    }
    /**
     * Set DocumentType value
     * @param string $documentType
     * @return \StructType\AddTemplateFile
     */
    public function setDocumentType($documentType = null)
    {
        // validation for constraint: string
        if (!is_null($documentType) && !is_string($documentType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($documentType)), __LINE__);
        }
        $this->DocumentType = $documentType;
        return $this;
    }
    /**
     * Get AddressFontCode value
     * @return string|null
     */
    public function getAddressFontCode()
    {
        return $this->AddressFontCode;
    }
    /**
     * Set AddressFontCode value
     * @param string $addressFontCode
     * @return \StructType\AddTemplateFile
     */
    public function setAddressFontCode($addressFontCode = null)
    {
        // validation for constraint: string
        if (!is_null($addressFontCode) && !is_string($addressFontCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addressFontCode)), __LINE__);
        }
        $this->AddressFontCode = $addressFontCode;
        return $this;
    }
    /**
     * Get TemplateType value
     * @return string|null
     */
    public function getTemplateType()
    {
        return $this->TemplateType;
    }
    /**
     * Set TemplateType value
     * @param string $templateType
     * @return \StructType\AddTemplateFile
     */
    public function setTemplateType($templateType = null)
    {
        // validation for constraint: string
        if (!is_null($templateType) && !is_string($templateType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($templateType)), __LINE__);
        }
        $this->TemplateType = $templateType;
        return $this;
    }
    /**
     * Get BackgroundName value
     * @return string|null
     */
    public function getBackgroundName()
    {
        return $this->BackgroundName;
    }
    /**
     * Set BackgroundName value
     * @param string $backgroundName
     * @return \StructType\AddTemplateFile
     */
    public function setBackgroundName($backgroundName = null)
    {
        // validation for constraint: string
        if (!is_null($backgroundName) && !is_string($backgroundName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($backgroundName)), __LINE__);
        }
        $this->BackgroundName = $backgroundName;
        return $this;
    }
    /**
     * Get ProtectedAreaPassword value
     * @return string|null
     */
    public function getProtectedAreaPassword()
    {
        return $this->ProtectedAreaPassword;
    }
    /**
     * Set ProtectedAreaPassword value
     * @param string $protectedAreaPassword
     * @return \StructType\AddTemplateFile
     */
    public function setProtectedAreaPassword($protectedAreaPassword = null)
    {
        // validation for constraint: string
        if (!is_null($protectedAreaPassword) && !is_string($protectedAreaPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($protectedAreaPassword)), __LINE__);
        }
        $this->ProtectedAreaPassword = $protectedAreaPassword;
        return $this;
    }
    /**
     * Get EncryptionPassword value
     * @return string|null
     */
    public function getEncryptionPassword()
    {
        return $this->EncryptionPassword;
    }
    /**
     * Set EncryptionPassword value
     * @param string $encryptionPassword
     * @return \StructType\AddTemplateFile
     */
    public function setEncryptionPassword($encryptionPassword = null)
    {
        // validation for constraint: string
        if (!is_null($encryptionPassword) && !is_string($encryptionPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($encryptionPassword)), __LINE__);
        }
        $this->EncryptionPassword = $encryptionPassword;
        return $this;
    }
    /**
     * Get InstancePageNumbers value
     * @return string|null
     */
    public function getInstancePageNumbers()
    {
        return $this->InstancePageNumbers;
    }
    /**
     * Set InstancePageNumbers value
     * @param string $instancePageNumbers
     * @return \StructType\AddTemplateFile
     */
    public function setInstancePageNumbers($instancePageNumbers = null)
    {
        // validation for constraint: string
        if (!is_null($instancePageNumbers) && !is_string($instancePageNumbers)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($instancePageNumbers)), __LINE__);
        }
        $this->InstancePageNumbers = $instancePageNumbers;
        return $this;
    }
    /**
     * Get ReturnFormat value
     * @return string|null
     */
    public function getReturnFormat()
    {
        return $this->ReturnFormat;
    }
    /**
     * Set ReturnFormat value
     * @param string $returnFormat
     * @return \StructType\AddTemplateFile
     */
    public function setReturnFormat($returnFormat = null)
    {
        // validation for constraint: string
        if (!is_null($returnFormat) && !is_string($returnFormat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($returnFormat)), __LINE__);
        }
        $this->ReturnFormat = $returnFormat;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddTemplateFile
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
