<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetMailingGUIDFromOrderRef StructType
 * @subpackage Structs
 */
class GetMailingGUIDFromOrderRef extends AbstractStructBase
{
    /**
     * The OrderRef
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $OrderRef;
    /**
     * The Username
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Username;
    /**
     * The Password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The ReturnFormat
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReturnFormat;
    /**
     * Constructor method for GetMailingGUIDFromOrderRef
     * @uses GetMailingGUIDFromOrderRef::setOrderRef()
     * @uses GetMailingGUIDFromOrderRef::setUsername()
     * @uses GetMailingGUIDFromOrderRef::setPassword()
     * @uses GetMailingGUIDFromOrderRef::setReturnFormat()
     * @param int $orderRef
     * @param string $username
     * @param string $password
     * @param string $returnFormat
     */
    public function __construct($orderRef = null, $username = null, $password = null, $returnFormat = null)
    {
        $this
            ->setOrderRef($orderRef)
            ->setUsername($username)
            ->setPassword($password)
            ->setReturnFormat($returnFormat);
    }
    /**
     * Get OrderRef value
     * @return int
     */
    public function getOrderRef()
    {
        return $this->OrderRef;
    }
    /**
     * Set OrderRef value
     * @param int $orderRef
     * @return \StructType\GetMailingGUIDFromOrderRef
     */
    public function setOrderRef($orderRef = null)
    {
        // validation for constraint: int
        if (!is_null($orderRef) && !is_numeric($orderRef)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($orderRef)), __LINE__);
        }
        $this->OrderRef = $orderRef;
        return $this;
    }
    /**
     * Get Username value
     * @return string|null
     */
    public function getUsername()
    {
        return $this->Username;
    }
    /**
     * Set Username value
     * @param string $username
     * @return \StructType\GetMailingGUIDFromOrderRef
     */
    public function setUsername($username = null)
    {
        // validation for constraint: string
        if (!is_null($username) && !is_string($username)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($username)), __LINE__);
        }
        $this->Username = $username;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\GetMailingGUIDFromOrderRef
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get ReturnFormat value
     * @return string|null
     */
    public function getReturnFormat()
    {
        return $this->ReturnFormat;
    }
    /**
     * Set ReturnFormat value
     * @param string $returnFormat
     * @return \StructType\GetMailingGUIDFromOrderRef
     */
    public function setReturnFormat($returnFormat = null)
    {
        // validation for constraint: string
        if (!is_null($returnFormat) && !is_string($returnFormat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($returnFormat)), __LINE__);
        }
        $this->ReturnFormat = $returnFormat;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetMailingGUIDFromOrderRef
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
