<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPriceEstimate StructType
 * @subpackage Structs
 */
class GetPriceEstimate extends AbstractStructBase
{
    /**
     * The IsMono
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsMono;
    /**
     * The IsDuplex
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsDuplex;
    /**
     * The Copies
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Copies;
    /**
     * The TotalSides
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $TotalSides;
    /**
     * The StandardAddressCount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $StandardAddressCount;
    /**
     * The SurchargeAddressCount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $SurchargeAddressCount;
    /**
     * The WesternEuropeAddressCount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $WesternEuropeAddressCount;
    /**
     * The RestOfTheWorldAddressCount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $RestOfTheWorldAddressCount;
    /**
     * The Username
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Username;
    /**
     * The Password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The DocumentType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DocumentType;
    /**
     * The DeliveryType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DeliveryType;
    /**
     * The DiscountCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DiscountCode;
    /**
     * The MinEnvelopeSize
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MinEnvelopeSize;
    /**
     * The EnvelopeGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $EnvelopeGroup;
    /**
     * The ReturnFormat
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReturnFormat;
    /**
     * Constructor method for GetPriceEstimate
     * @uses GetPriceEstimate::setIsMono()
     * @uses GetPriceEstimate::setIsDuplex()
     * @uses GetPriceEstimate::setCopies()
     * @uses GetPriceEstimate::setTotalSides()
     * @uses GetPriceEstimate::setStandardAddressCount()
     * @uses GetPriceEstimate::setSurchargeAddressCount()
     * @uses GetPriceEstimate::setWesternEuropeAddressCount()
     * @uses GetPriceEstimate::setRestOfTheWorldAddressCount()
     * @uses GetPriceEstimate::setUsername()
     * @uses GetPriceEstimate::setPassword()
     * @uses GetPriceEstimate::setDocumentType()
     * @uses GetPriceEstimate::setDeliveryType()
     * @uses GetPriceEstimate::setDiscountCode()
     * @uses GetPriceEstimate::setMinEnvelopeSize()
     * @uses GetPriceEstimate::setEnvelopeGroup()
     * @uses GetPriceEstimate::setReturnFormat()
     * @param bool $isMono
     * @param bool $isDuplex
     * @param int $copies
     * @param int $totalSides
     * @param int $standardAddressCount
     * @param int $surchargeAddressCount
     * @param int $westernEuropeAddressCount
     * @param int $restOfTheWorldAddressCount
     * @param string $username
     * @param string $password
     * @param string $documentType
     * @param string $deliveryType
     * @param string $discountCode
     * @param string $minEnvelopeSize
     * @param string $envelopeGroup
     * @param string $returnFormat
     */
    public function __construct($isMono = null, $isDuplex = null, $copies = null, $totalSides = null, $standardAddressCount = null, $surchargeAddressCount = null, $westernEuropeAddressCount = null, $restOfTheWorldAddressCount = null, $username = null, $password = null, $documentType = null, $deliveryType = null, $discountCode = null, $minEnvelopeSize = null, $envelopeGroup = null, $returnFormat = null)
    {
        $this
            ->setIsMono($isMono)
            ->setIsDuplex($isDuplex)
            ->setCopies($copies)
            ->setTotalSides($totalSides)
            ->setStandardAddressCount($standardAddressCount)
            ->setSurchargeAddressCount($surchargeAddressCount)
            ->setWesternEuropeAddressCount($westernEuropeAddressCount)
            ->setRestOfTheWorldAddressCount($restOfTheWorldAddressCount)
            ->setUsername($username)
            ->setPassword($password)
            ->setDocumentType($documentType)
            ->setDeliveryType($deliveryType)
            ->setDiscountCode($discountCode)
            ->setMinEnvelopeSize($minEnvelopeSize)
            ->setEnvelopeGroup($envelopeGroup)
            ->setReturnFormat($returnFormat);
    }
    /**
     * Get IsMono value
     * @return bool
     */
    public function getIsMono()
    {
        return $this->IsMono;
    }
    /**
     * Set IsMono value
     * @param bool $isMono
     * @return \StructType\GetPriceEstimate
     */
    public function setIsMono($isMono = null)
    {
        // validation for constraint: boolean
        if (!is_null($isMono) && !is_bool($isMono)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isMono)), __LINE__);
        }
        $this->IsMono = $isMono;
        return $this;
    }
    /**
     * Get IsDuplex value
     * @return bool
     */
    public function getIsDuplex()
    {
        return $this->IsDuplex;
    }
    /**
     * Set IsDuplex value
     * @param bool $isDuplex
     * @return \StructType\GetPriceEstimate
     */
    public function setIsDuplex($isDuplex = null)
    {
        // validation for constraint: boolean
        if (!is_null($isDuplex) && !is_bool($isDuplex)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isDuplex)), __LINE__);
        }
        $this->IsDuplex = $isDuplex;
        return $this;
    }
    /**
     * Get Copies value
     * @return int
     */
    public function getCopies()
    {
        return $this->Copies;
    }
    /**
     * Set Copies value
     * @param int $copies
     * @return \StructType\GetPriceEstimate
     */
    public function setCopies($copies = null)
    {
        // validation for constraint: int
        if (!is_null($copies) && !is_numeric($copies)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($copies)), __LINE__);
        }
        $this->Copies = $copies;
        return $this;
    }
    /**
     * Get TotalSides value
     * @return int
     */
    public function getTotalSides()
    {
        return $this->TotalSides;
    }
    /**
     * Set TotalSides value
     * @param int $totalSides
     * @return \StructType\GetPriceEstimate
     */
    public function setTotalSides($totalSides = null)
    {
        // validation for constraint: int
        if (!is_null($totalSides) && !is_numeric($totalSides)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($totalSides)), __LINE__);
        }
        $this->TotalSides = $totalSides;
        return $this;
    }
    /**
     * Get StandardAddressCount value
     * @return int
     */
    public function getStandardAddressCount()
    {
        return $this->StandardAddressCount;
    }
    /**
     * Set StandardAddressCount value
     * @param int $standardAddressCount
     * @return \StructType\GetPriceEstimate
     */
    public function setStandardAddressCount($standardAddressCount = null)
    {
        // validation for constraint: int
        if (!is_null($standardAddressCount) && !is_numeric($standardAddressCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($standardAddressCount)), __LINE__);
        }
        $this->StandardAddressCount = $standardAddressCount;
        return $this;
    }
    /**
     * Get SurchargeAddressCount value
     * @return int
     */
    public function getSurchargeAddressCount()
    {
        return $this->SurchargeAddressCount;
    }
    /**
     * Set SurchargeAddressCount value
     * @param int $surchargeAddressCount
     * @return \StructType\GetPriceEstimate
     */
    public function setSurchargeAddressCount($surchargeAddressCount = null)
    {
        // validation for constraint: int
        if (!is_null($surchargeAddressCount) && !is_numeric($surchargeAddressCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($surchargeAddressCount)), __LINE__);
        }
        $this->SurchargeAddressCount = $surchargeAddressCount;
        return $this;
    }
    /**
     * Get WesternEuropeAddressCount value
     * @return int
     */
    public function getWesternEuropeAddressCount()
    {
        return $this->WesternEuropeAddressCount;
    }
    /**
     * Set WesternEuropeAddressCount value
     * @param int $westernEuropeAddressCount
     * @return \StructType\GetPriceEstimate
     */
    public function setWesternEuropeAddressCount($westernEuropeAddressCount = null)
    {
        // validation for constraint: int
        if (!is_null($westernEuropeAddressCount) && !is_numeric($westernEuropeAddressCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($westernEuropeAddressCount)), __LINE__);
        }
        $this->WesternEuropeAddressCount = $westernEuropeAddressCount;
        return $this;
    }
    /**
     * Get RestOfTheWorldAddressCount value
     * @return int
     */
    public function getRestOfTheWorldAddressCount()
    {
        return $this->RestOfTheWorldAddressCount;
    }
    /**
     * Set RestOfTheWorldAddressCount value
     * @param int $restOfTheWorldAddressCount
     * @return \StructType\GetPriceEstimate
     */
    public function setRestOfTheWorldAddressCount($restOfTheWorldAddressCount = null)
    {
        // validation for constraint: int
        if (!is_null($restOfTheWorldAddressCount) && !is_numeric($restOfTheWorldAddressCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($restOfTheWorldAddressCount)), __LINE__);
        }
        $this->RestOfTheWorldAddressCount = $restOfTheWorldAddressCount;
        return $this;
    }
    /**
     * Get Username value
     * @return string|null
     */
    public function getUsername()
    {
        return $this->Username;
    }
    /**
     * Set Username value
     * @param string $username
     * @return \StructType\GetPriceEstimate
     */
    public function setUsername($username = null)
    {
        // validation for constraint: string
        if (!is_null($username) && !is_string($username)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($username)), __LINE__);
        }
        $this->Username = $username;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\GetPriceEstimate
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get DocumentType value
     * @return string|null
     */
    public function getDocumentType()
    {
        return $this->DocumentType;
    }
    /**
     * Set DocumentType value
     * @param string $documentType
     * @return \StructType\GetPriceEstimate
     */
    public function setDocumentType($documentType = null)
    {
        // validation for constraint: string
        if (!is_null($documentType) && !is_string($documentType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($documentType)), __LINE__);
        }
        $this->DocumentType = $documentType;
        return $this;
    }
    /**
     * Get DeliveryType value
     * @return string|null
     */
    public function getDeliveryType()
    {
        return $this->DeliveryType;
    }
    /**
     * Set DeliveryType value
     * @param string $deliveryType
     * @return \StructType\GetPriceEstimate
     */
    public function setDeliveryType($deliveryType = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryType) && !is_string($deliveryType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deliveryType)), __LINE__);
        }
        $this->DeliveryType = $deliveryType;
        return $this;
    }
    /**
     * Get DiscountCode value
     * @return string|null
     */
    public function getDiscountCode()
    {
        return $this->DiscountCode;
    }
    /**
     * Set DiscountCode value
     * @param string $discountCode
     * @return \StructType\GetPriceEstimate
     */
    public function setDiscountCode($discountCode = null)
    {
        // validation for constraint: string
        if (!is_null($discountCode) && !is_string($discountCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($discountCode)), __LINE__);
        }
        $this->DiscountCode = $discountCode;
        return $this;
    }
    /**
     * Get MinEnvelopeSize value
     * @return string|null
     */
    public function getMinEnvelopeSize()
    {
        return $this->MinEnvelopeSize;
    }
    /**
     * Set MinEnvelopeSize value
     * @param string $minEnvelopeSize
     * @return \StructType\GetPriceEstimate
     */
    public function setMinEnvelopeSize($minEnvelopeSize = null)
    {
        // validation for constraint: string
        if (!is_null($minEnvelopeSize) && !is_string($minEnvelopeSize)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($minEnvelopeSize)), __LINE__);
        }
        $this->MinEnvelopeSize = $minEnvelopeSize;
        return $this;
    }
    /**
     * Get EnvelopeGroup value
     * @return string|null
     */
    public function getEnvelopeGroup()
    {
        return $this->EnvelopeGroup;
    }
    /**
     * Set EnvelopeGroup value
     * @param string $envelopeGroup
     * @return \StructType\GetPriceEstimate
     */
    public function setEnvelopeGroup($envelopeGroup = null)
    {
        // validation for constraint: string
        if (!is_null($envelopeGroup) && !is_string($envelopeGroup)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($envelopeGroup)), __LINE__);
        }
        $this->EnvelopeGroup = $envelopeGroup;
        return $this;
    }
    /**
     * Get ReturnFormat value
     * @return string|null
     */
    public function getReturnFormat()
    {
        return $this->ReturnFormat;
    }
    /**
     * Set ReturnFormat value
     * @param string $returnFormat
     * @return \StructType\GetPriceEstimate
     */
    public function setReturnFormat($returnFormat = null)
    {
        // validation for constraint: string
        if (!is_null($returnFormat) && !is_string($returnFormat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($returnFormat)), __LINE__);
        }
        $this->ReturnFormat = $returnFormat;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetPriceEstimate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
