<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListLibraryTemplatesPageCount StructType
 * @subpackage Structs
 */
class ListLibraryTemplatesPageCount extends AbstractStructBase
{
    /**
     * The AddressedDocumentsOnly
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $AddressedDocumentsOnly;
    /**
     * The Inserts
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Inserts;
    /**
     * The PageSize
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $PageSize;
    /**
     * The Username
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Username;
    /**
     * The Password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The ProductType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ProductType;
    /**
     * The SearchText
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SearchText;
    /**
     * The ReturnFormat
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReturnFormat;
    /**
     * Constructor method for ListLibraryTemplatesPageCount
     * @uses ListLibraryTemplatesPageCount::setAddressedDocumentsOnly()
     * @uses ListLibraryTemplatesPageCount::setInserts()
     * @uses ListLibraryTemplatesPageCount::setPageSize()
     * @uses ListLibraryTemplatesPageCount::setUsername()
     * @uses ListLibraryTemplatesPageCount::setPassword()
     * @uses ListLibraryTemplatesPageCount::setProductType()
     * @uses ListLibraryTemplatesPageCount::setSearchText()
     * @uses ListLibraryTemplatesPageCount::setReturnFormat()
     * @param bool $addressedDocumentsOnly
     * @param bool $inserts
     * @param int $pageSize
     * @param string $username
     * @param string $password
     * @param string $productType
     * @param string $searchText
     * @param string $returnFormat
     */
    public function __construct($addressedDocumentsOnly = null, $inserts = null, $pageSize = null, $username = null, $password = null, $productType = null, $searchText = null, $returnFormat = null)
    {
        $this
            ->setAddressedDocumentsOnly($addressedDocumentsOnly)
            ->setInserts($inserts)
            ->setPageSize($pageSize)
            ->setUsername($username)
            ->setPassword($password)
            ->setProductType($productType)
            ->setSearchText($searchText)
            ->setReturnFormat($returnFormat);
    }
    /**
     * Get AddressedDocumentsOnly value
     * @return bool
     */
    public function getAddressedDocumentsOnly()
    {
        return $this->AddressedDocumentsOnly;
    }
    /**
     * Set AddressedDocumentsOnly value
     * @param bool $addressedDocumentsOnly
     * @return \StructType\ListLibraryTemplatesPageCount
     */
    public function setAddressedDocumentsOnly($addressedDocumentsOnly = null)
    {
        // validation for constraint: boolean
        if (!is_null($addressedDocumentsOnly) && !is_bool($addressedDocumentsOnly)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($addressedDocumentsOnly)), __LINE__);
        }
        $this->AddressedDocumentsOnly = $addressedDocumentsOnly;
        return $this;
    }
    /**
     * Get Inserts value
     * @return bool
     */
    public function getInserts()
    {
        return $this->Inserts;
    }
    /**
     * Set Inserts value
     * @param bool $inserts
     * @return \StructType\ListLibraryTemplatesPageCount
     */
    public function setInserts($inserts = null)
    {
        // validation for constraint: boolean
        if (!is_null($inserts) && !is_bool($inserts)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($inserts)), __LINE__);
        }
        $this->Inserts = $inserts;
        return $this;
    }
    /**
     * Get PageSize value
     * @return int
     */
    public function getPageSize()
    {
        return $this->PageSize;
    }
    /**
     * Set PageSize value
     * @param int $pageSize
     * @return \StructType\ListLibraryTemplatesPageCount
     */
    public function setPageSize($pageSize = null)
    {
        // validation for constraint: int
        if (!is_null($pageSize) && !is_numeric($pageSize)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($pageSize)), __LINE__);
        }
        $this->PageSize = $pageSize;
        return $this;
    }
    /**
     * Get Username value
     * @return string|null
     */
    public function getUsername()
    {
        return $this->Username;
    }
    /**
     * Set Username value
     * @param string $username
     * @return \StructType\ListLibraryTemplatesPageCount
     */
    public function setUsername($username = null)
    {
        // validation for constraint: string
        if (!is_null($username) && !is_string($username)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($username)), __LINE__);
        }
        $this->Username = $username;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\ListLibraryTemplatesPageCount
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get ProductType value
     * @return string|null
     */
    public function getProductType()
    {
        return $this->ProductType;
    }
    /**
     * Set ProductType value
     * @param string $productType
     * @return \StructType\ListLibraryTemplatesPageCount
     */
    public function setProductType($productType = null)
    {
        // validation for constraint: string
        if (!is_null($productType) && !is_string($productType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($productType)), __LINE__);
        }
        $this->ProductType = $productType;
        return $this;
    }
    /**
     * Get SearchText value
     * @return string|null
     */
    public function getSearchText()
    {
        return $this->SearchText;
    }
    /**
     * Set SearchText value
     * @param string $searchText
     * @return \StructType\ListLibraryTemplatesPageCount
     */
    public function setSearchText($searchText = null)
    {
        // validation for constraint: string
        if (!is_null($searchText) && !is_string($searchText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($searchText)), __LINE__);
        }
        $this->SearchText = $searchText;
        return $this;
    }
    /**
     * Get ReturnFormat value
     * @return string|null
     */
    public function getReturnFormat()
    {
        return $this->ReturnFormat;
    }
    /**
     * Set ReturnFormat value
     * @param string $returnFormat
     * @return \StructType\ListLibraryTemplatesPageCount
     */
    public function setReturnFormat($returnFormat = null)
    {
        // validation for constraint: string
        if (!is_null($returnFormat) && !is_string($returnFormat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($returnFormat)), __LINE__);
        }
        $this->ReturnFormat = $returnFormat;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ListLibraryTemplatesPageCount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
