<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListMailingsPageCount StructType
 * @subpackage Structs
 */
class ListMailingsPageCount extends AbstractStructBase
{
    /**
     * The SubmittedFrom
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $SubmittedFrom;
    /**
     * The SubmittedTo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $SubmittedTo;
    /**
     * The OutstandingOnly
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $OutstandingOnly;
    /**
     * The AllUsers
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $AllUsers;
    /**
     * The CanContentApproveOnly
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $CanContentApproveOnly;
    /**
     * The CanBudgetApproveOnly
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $CanBudgetApproveOnly;
    /**
     * The PageSize
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $PageSize;
    /**
     * The Username
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Username;
    /**
     * The Password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The ProductType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ProductType;
    /**
     * The SearchText
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SearchText;
    /**
     * The CustomerApplication
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CustomerApplication;
    /**
     * The ReturnFormat
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReturnFormat;
    /**
     * Constructor method for ListMailingsPageCount
     * @uses ListMailingsPageCount::setSubmittedFrom()
     * @uses ListMailingsPageCount::setSubmittedTo()
     * @uses ListMailingsPageCount::setOutstandingOnly()
     * @uses ListMailingsPageCount::setAllUsers()
     * @uses ListMailingsPageCount::setCanContentApproveOnly()
     * @uses ListMailingsPageCount::setCanBudgetApproveOnly()
     * @uses ListMailingsPageCount::setPageSize()
     * @uses ListMailingsPageCount::setUsername()
     * @uses ListMailingsPageCount::setPassword()
     * @uses ListMailingsPageCount::setProductType()
     * @uses ListMailingsPageCount::setSearchText()
     * @uses ListMailingsPageCount::setCustomerApplication()
     * @uses ListMailingsPageCount::setReturnFormat()
     * @param string $submittedFrom
     * @param string $submittedTo
     * @param bool $outstandingOnly
     * @param bool $allUsers
     * @param bool $canContentApproveOnly
     * @param bool $canBudgetApproveOnly
     * @param int $pageSize
     * @param string $username
     * @param string $password
     * @param string $productType
     * @param string $searchText
     * @param string $customerApplication
     * @param string $returnFormat
     */
    public function __construct($submittedFrom = null, $submittedTo = null, $outstandingOnly = null, $allUsers = null, $canContentApproveOnly = null, $canBudgetApproveOnly = null, $pageSize = null, $username = null, $password = null, $productType = null, $searchText = null, $customerApplication = null, $returnFormat = null)
    {
        $this
            ->setSubmittedFrom($submittedFrom)
            ->setSubmittedTo($submittedTo)
            ->setOutstandingOnly($outstandingOnly)
            ->setAllUsers($allUsers)
            ->setCanContentApproveOnly($canContentApproveOnly)
            ->setCanBudgetApproveOnly($canBudgetApproveOnly)
            ->setPageSize($pageSize)
            ->setUsername($username)
            ->setPassword($password)
            ->setProductType($productType)
            ->setSearchText($searchText)
            ->setCustomerApplication($customerApplication)
            ->setReturnFormat($returnFormat);
    }
    /**
     * Get SubmittedFrom value
     * @return string
     */
    public function getSubmittedFrom()
    {
        return $this->SubmittedFrom;
    }
    /**
     * Set SubmittedFrom value
     * @param string $submittedFrom
     * @return \StructType\ListMailingsPageCount
     */
    public function setSubmittedFrom($submittedFrom = null)
    {
        // validation for constraint: string
        if (!is_null($submittedFrom) && !is_string($submittedFrom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($submittedFrom)), __LINE__);
        }
        $this->SubmittedFrom = $submittedFrom;
        return $this;
    }
    /**
     * Get SubmittedTo value
     * @return string
     */
    public function getSubmittedTo()
    {
        return $this->SubmittedTo;
    }
    /**
     * Set SubmittedTo value
     * @param string $submittedTo
     * @return \StructType\ListMailingsPageCount
     */
    public function setSubmittedTo($submittedTo = null)
    {
        // validation for constraint: string
        if (!is_null($submittedTo) && !is_string($submittedTo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($submittedTo)), __LINE__);
        }
        $this->SubmittedTo = $submittedTo;
        return $this;
    }
    /**
     * Get OutstandingOnly value
     * @return bool
     */
    public function getOutstandingOnly()
    {
        return $this->OutstandingOnly;
    }
    /**
     * Set OutstandingOnly value
     * @param bool $outstandingOnly
     * @return \StructType\ListMailingsPageCount
     */
    public function setOutstandingOnly($outstandingOnly = null)
    {
        // validation for constraint: boolean
        if (!is_null($outstandingOnly) && !is_bool($outstandingOnly)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($outstandingOnly)), __LINE__);
        }
        $this->OutstandingOnly = $outstandingOnly;
        return $this;
    }
    /**
     * Get AllUsers value
     * @return bool
     */
    public function getAllUsers()
    {
        return $this->AllUsers;
    }
    /**
     * Set AllUsers value
     * @param bool $allUsers
     * @return \StructType\ListMailingsPageCount
     */
    public function setAllUsers($allUsers = null)
    {
        // validation for constraint: boolean
        if (!is_null($allUsers) && !is_bool($allUsers)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($allUsers)), __LINE__);
        }
        $this->AllUsers = $allUsers;
        return $this;
    }
    /**
     * Get CanContentApproveOnly value
     * @return bool
     */
    public function getCanContentApproveOnly()
    {
        return $this->CanContentApproveOnly;
    }
    /**
     * Set CanContentApproveOnly value
     * @param bool $canContentApproveOnly
     * @return \StructType\ListMailingsPageCount
     */
    public function setCanContentApproveOnly($canContentApproveOnly = null)
    {
        // validation for constraint: boolean
        if (!is_null($canContentApproveOnly) && !is_bool($canContentApproveOnly)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($canContentApproveOnly)), __LINE__);
        }
        $this->CanContentApproveOnly = $canContentApproveOnly;
        return $this;
    }
    /**
     * Get CanBudgetApproveOnly value
     * @return bool
     */
    public function getCanBudgetApproveOnly()
    {
        return $this->CanBudgetApproveOnly;
    }
    /**
     * Set CanBudgetApproveOnly value
     * @param bool $canBudgetApproveOnly
     * @return \StructType\ListMailingsPageCount
     */
    public function setCanBudgetApproveOnly($canBudgetApproveOnly = null)
    {
        // validation for constraint: boolean
        if (!is_null($canBudgetApproveOnly) && !is_bool($canBudgetApproveOnly)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($canBudgetApproveOnly)), __LINE__);
        }
        $this->CanBudgetApproveOnly = $canBudgetApproveOnly;
        return $this;
    }
    /**
     * Get PageSize value
     * @return int
     */
    public function getPageSize()
    {
        return $this->PageSize;
    }
    /**
     * Set PageSize value
     * @param int $pageSize
     * @return \StructType\ListMailingsPageCount
     */
    public function setPageSize($pageSize = null)
    {
        // validation for constraint: int
        if (!is_null($pageSize) && !is_numeric($pageSize)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($pageSize)), __LINE__);
        }
        $this->PageSize = $pageSize;
        return $this;
    }
    /**
     * Get Username value
     * @return string|null
     */
    public function getUsername()
    {
        return $this->Username;
    }
    /**
     * Set Username value
     * @param string $username
     * @return \StructType\ListMailingsPageCount
     */
    public function setUsername($username = null)
    {
        // validation for constraint: string
        if (!is_null($username) && !is_string($username)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($username)), __LINE__);
        }
        $this->Username = $username;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\ListMailingsPageCount
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get ProductType value
     * @return string|null
     */
    public function getProductType()
    {
        return $this->ProductType;
    }
    /**
     * Set ProductType value
     * @param string $productType
     * @return \StructType\ListMailingsPageCount
     */
    public function setProductType($productType = null)
    {
        // validation for constraint: string
        if (!is_null($productType) && !is_string($productType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($productType)), __LINE__);
        }
        $this->ProductType = $productType;
        return $this;
    }
    /**
     * Get SearchText value
     * @return string|null
     */
    public function getSearchText()
    {
        return $this->SearchText;
    }
    /**
     * Set SearchText value
     * @param string $searchText
     * @return \StructType\ListMailingsPageCount
     */
    public function setSearchText($searchText = null)
    {
        // validation for constraint: string
        if (!is_null($searchText) && !is_string($searchText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($searchText)), __LINE__);
        }
        $this->SearchText = $searchText;
        return $this;
    }
    /**
     * Get CustomerApplication value
     * @return string|null
     */
    public function getCustomerApplication()
    {
        return $this->CustomerApplication;
    }
    /**
     * Set CustomerApplication value
     * @param string $customerApplication
     * @return \StructType\ListMailingsPageCount
     */
    public function setCustomerApplication($customerApplication = null)
    {
        // validation for constraint: string
        if (!is_null($customerApplication) && !is_string($customerApplication)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customerApplication)), __LINE__);
        }
        $this->CustomerApplication = $customerApplication;
        return $this;
    }
    /**
     * Get ReturnFormat value
     * @return string|null
     */
    public function getReturnFormat()
    {
        return $this->ReturnFormat;
    }
    /**
     * Set ReturnFormat value
     * @param string $returnFormat
     * @return \StructType\ListMailingsPageCount
     */
    public function setReturnFormat($returnFormat = null)
    {
        // validation for constraint: string
        if (!is_null($returnFormat) && !is_string($returnFormat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($returnFormat)), __LINE__);
        }
        $this->ReturnFormat = $returnFormat;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ListMailingsPageCount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
